packagename=names.nick.openoffice
slashname=`echo $packagename | sed 's/\./\//g'`
colenname=`echo $packagename | sed 's/\./::/g'`
Component=TestOOComp

# First compile Interface and Service UNO-IDL definitions into .urd files.
# Note that the Service is only needed for uno-skeletonmaker to generate the skeleton code from XTestOOComp.
# It and the associated class file created by javamaker are not appear to be needed for a java implementation of TestOOComp to actually run.
#
idlc -w -I /usr/share/idl/openoffice -I $Component/idl $Component/idl/$slashname/$Component.idl


# Next merge .urd files into .rdb type library
#
rm -f $Component/${Component}types.rdb
regmerge $Component/${Component}types.rdb /UCR $Component/idl/$slashname/$Component.urd

# regview.txt can be reviewed to check details of the type library just created:
#
regview $Component/${Component}types.rdb > $Component/regview.txt


# Using the just created .rdb type library, generate java class files needed in following java code component implentation
#
javamaker -Tnames.* -nD -Gc -BUCR -O ./$Component/java $Component/${Component}types.rdb


# Generate skeleton java code -- CAREFUL:  This wipes out any code previously added to your java source code - MAKE SURE IT'S BACKED UP FIRST
#
# uno-skeletonmaker -env:BOOTSTRAPINI="/usr/lib/openoffice/program/bootstraprc" component --java5 -o ./$Component/java -l /usr/lib/ure/share/misc/types.rdb -l $Component/${Component}types.rdb -n $packagename.${Component}JavaImpl  -t $packagename.S${Component}

# Now edit the just created skeleton java code to implement the methods and properties of the component

# Last steps:
#  1) Compile your edited java code (using either javac or gcj) into a .class file
#
# javac -cp "/usr/share/java/openoffice/ridl.jar:/usr/share/java/openoffice/juh.jar:$Component/java" $Component/java/$slashname/${Component}JavaImpl.java
gcj -C -I "/usr/share/java/openoffice/ridl.jar:/usr/share/java/openoffice/juh.jar:$Component/java" $Component/java/$slashname/${Component}JavaImpl.java

#  2) Create Manifest file
#
echo "RegistrationClassName: $packagename.${Component}JavaImpl" > $Component/OOjarManifest.mf

#  3) Generate a .jar file containing the Manifest and compiled java .class files
#
jar cvfm $Component/${Component}Impl.jar $Component/OOjarManifest.mf -C $Component/java .
